"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var DropdownMenuItemDirective = (function () {
    function DropdownMenuItemDirective(el, renderer) {
        this.el = el;
        this.renderer = renderer;
    }
    DropdownMenuItemDirective.prototype.ngOnInit = function () {
        var children = this.el.nativeElement.children;
        for (var _i = 0, children_1 = children; _i < children_1.length; _i++) {
            var child = children_1[_i];
            if (child.nodeName === 'UL' && child.classList.contains('menu')) {
                this.ulChild = child;
            }
        }
        var topLevel = this.el.nativeElement.parentElement.hasAttribute('dropdown-menu');
        if (!topLevel) {
            this.renderer.setElementClass(this.el.nativeElement, 'is-submenu-item', true);
        }
        if (this.ulChild) {
            this.renderer.setElementClass(this.ulChild, 'is-dropdown-submenu', true);
            this.renderer.setElementClass(this.ulChild, 'menu', true);
            this.renderer.setElementClass(this.ulChild, 'submenu', true);
            this.renderer.setElementClass(this.ulChild, 'vertical', true);
            this.renderer.setElementClass(this.el.nativeElement, 'is-dropdown-submenu-parent', true);
            this.renderer.setElementClass(this.el.nativeElement, 'opens-right', true);
            if (topLevel) {
                this.renderer.setElementClass(this.ulChild, 'first-sub', true);
            }
        }
    };
    DropdownMenuItemDirective.prototype.mouseEnter = function () {
        if (this.ulChild) {
            var siblings = this.el.nativeElement.parentElement.children;
            for (var _i = 0, siblings_1 = siblings; _i < siblings_1.length; _i++) {
                var sibling = siblings_1[_i];
                for (var _a = 0, _b = sibling.children; _a < _b.length; _a++) {
                    var child = _b[_a];
                    this.renderer.setElementClass(child, 'js-dropdown-active', false);
                }
            }
            this.renderer.setElementClass(this.ulChild, 'js-dropdown-active', true);
            this.renderer.setElementClass(this.el.nativeElement, 'is-active', true);
        }
    };
    DropdownMenuItemDirective.prototype.mouseLeave = function () {
        if (this.ulChild) {
            this.renderer.setElementClass(this.ulChild, 'js-dropdown-active', false);
            this.renderer.setElementClass(this.el.nativeElement, 'is-active', false);
        }
    };
    DropdownMenuItemDirective.prototype.click = function () {
        if (this.ulChild) {
            this.renderer.setElementClass(this.ulChild, 'js-dropdown-active', true);
            this.renderer.setElementClass(this.el.nativeElement, 'is-active', true);
        }
    };
    __decorate([
        core_1.HostListener('mouseenter'), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], DropdownMenuItemDirective.prototype, "mouseEnter", null);
    __decorate([
        core_1.HostListener('mouseleave'), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], DropdownMenuItemDirective.prototype, "mouseLeave", null);
    __decorate([
        core_1.HostListener('click'), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], DropdownMenuItemDirective.prototype, "click", null);
    DropdownMenuItemDirective = __decorate([
        core_1.Directive({ selector: 'li' }), 
        __metadata('design:paramtypes', [core_1.ElementRef, core_1.Renderer])
    ], DropdownMenuItemDirective);
    return DropdownMenuItemDirective;
}());
exports.DropdownMenuItemDirective = DropdownMenuItemDirective;
