"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var dropdown_directive_1 = require('./dropdown.directive');
var position_1 = require('../position');
var DropdownTogglePaneDirective = (function () {
    function DropdownTogglePaneDirective(dropdown, el, renderer) {
        this.alignment = null;
        this.dropdown = dropdown;
        this.el = el;
        this.renderer = renderer;
    }
    DropdownTogglePaneDirective.prototype.ngOnInit = function () {
        this.dropdown.dropDownMenu = this;
        this.alignment = this.el.nativeElement.getAttribute('pane-align');
        this.renderer.setElementClass(this.el.nativeElement, "dropdown-pane", true);
    };
    DropdownTogglePaneDirective.prototype.ngAfterViewChecked = function () {
        switch (this.alignment) {
            case 'center':
            case 'right':
                this.renderer.setElementClass(this.el.nativeElement, "dropdown-pane-" + this.alignment, true);
                break;
        }
        var button = this.el.nativeElement.parentElement.children[0];
        if (button) {
            var elePosition = position_1.positionService.position(this.el.nativeElement);
            var buttonPosition = position_1.positionService.position(button);
            this.renderer.setElementStyle(this.el.nativeElement, 'top', (buttonPosition.top + buttonPosition.height + 2) + "px");
            switch (this.alignment) {
                case 'center':
                    if (elePosition.width < buttonPosition.width) {
                        this.renderer.setElementStyle(this.el.nativeElement, 'left', (buttonPosition.left + buttonPosition.width / 2) + "px");
                        this.renderer.setElementStyle(this.el.nativeElement, 'transform', 'translateX(-50%)');
                    }
                    break;
                case 'right':
                    this.renderer.setElementStyle(this.el.nativeElement, 'left', (buttonPosition.left + buttonPosition.width) + "px");
                    this.renderer.setElementStyle(this.el.nativeElement, 'transform', 'translateX(-100%)');
                    break;
            }
        }
    };
    Object.defineProperty(DropdownTogglePaneDirective.prototype, "isOpen", {
        get: function () {
            return this.dropdown.isOpen;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_1.HostBinding('attr.aria-hidden'),
        core_1.HostBinding('class.is-open'), 
        __metadata('design:type', Boolean)
    ], DropdownTogglePaneDirective.prototype, "isOpen", null);
    DropdownTogglePaneDirective = __decorate([
        core_1.Directive({ selector: '[dropdownTogglePane]' }),
        __param(0, core_1.Host()), 
        __metadata('design:paramtypes', [dropdown_directive_1.DropdownDirective, core_1.ElementRef, core_1.Renderer])
    ], DropdownTogglePaneDirective);
    return DropdownTogglePaneDirective;
}());
exports.DropdownTogglePaneDirective = DropdownTogglePaneDirective;
